@echo off

set "baseSysDev=Base System Device"
setlocal EnableExtensions EnableDelayedExpansion

devcon rescan
devcon find "PCI\VEN_8086&DEV_12*" > %windir%\Logs\devices.txt
set "DevicesFile=%windir%\Logs\devices.txt"
for /f "delims=" %%a in ('Type "%DevicesFile%"') do (
    set /a count+=1
    set "Line[!count!]=%%a"
)
rem create device id's array
set "DevicesFile=.\HW_IDs.txt"
for /f "delims=" %%a in ('Type "%DevicesFile%"') do (
    set /a hw_ids_count+=1
    set "hw_ids_arr[!hw_ids_count!]=%%a"
)

For /L %%i in (1,1,%Count%) do (
	echo "!Line[%%i]!" | findstr /C:"!baseSysDev!" 1>nul
	if errorlevel 1 (
	rem pattern not found --> device is not base system device. check device ...
	rem go over each one of thedevice ids to make the check
	For /L %%j in (1,1,%hw_ids_count%) do (
		echo "!Line[%%i]!" | findstr /C:"!hw_ids_arr[%%j]!" 1>nul
		if errorlevel 1 (
			rem pattern not found
		) ELSE (
		rem got zero found pattern
		echo "Device driver is installing ..."
		set deviceName="!hw_ids_arr[%%j]!"
            %~dp0devcon update "%~dp0driver\e2fn.inf" !deviceName!
            )
		)
	) ELSE (
		rem got zero found pattern
		echo "Base System Device found, proceeding..."
	)
	
)

devcon rescan

del %windir%\Logs\devices.txt

:EXIT

exit /b 0